<?php


namespace App\ViewModels\Setor\SetorDetailsViewModel;


use App\Utils\Builder;
use App\ViewModels\Setor\SetorRegistrationViewModel\SetorRegistrationViewModel;

class SetorDetailsViewModelBuilder implements Builder
{
    private $id;
    private $descricao;
    private $id_centro_custo;
    private $descricao_centro_custo;
    private $criado_em;
    private $atualizado_em;
    private $desativado_em;
    private $criado_por;
    private $alterado_por;
    private $desativado_por;

    /**
     * @param mixed $descricao_centro_custo
     * @return SetorDetailsViewModelBuilder
     */
    public function setDescricaoCentroCusto($descricao_centro_custo)
    {
        $this->descricao_centro_custo = $descricao_centro_custo;
        return $this;
    }

    /**
     * @param mixed $id_centro_custo
     * @return SetorDetailsViewModelBuilder
     */
    public function setIdCentroCusto($id_centro_custo)
    {
        $this->id_centro_custo = $id_centro_custo;
        return $this;
    }

    /**
     * @param mixed $id
     * @return SetorDetailsViewModelBuilder
     */
    public function setId($id)
    {
        $this->id = $id;
        return $this;
    }

    /**
     * @param mixed $descricao
     * @return SetorDetailsViewModelBuilder
     */
    public function setDescricao($descricao)
    {
        $this->descricao = $descricao;
        return $this;
    }

    /**
     * @param mixed $criado_em
     * @return SetorDetailsViewModelBuilder
     */
    public function setCriadoEm($criado_em)
    {
        $this->criado_em = $criado_em;
        return $this;
    }

    /**
     * @param mixed $atualizado_em
     * @return SetorDetailsViewModelBuilder
     */
    public function setAtualizadoEm($atualizado_em)
    {
        $this->atualizado_em = $atualizado_em;
        return $this;
    }

    /**
     * @param mixed $desativado_em
     * @return SetorDetailsViewModelBuilder
     */
    public function setDesativadoEm($desativado_em)
    {
        $this->desativado_em = $desativado_em;
        return $this;
    }

    /**
     * @param mixed $criado_por
     * @return SetorDetailsViewModelBuilder
     */
    public function setCriadoPor($criado_por)
    {
        $this->criado_por = $criado_por;
        return $this;
    }

    /**
     * @param mixed $alterado_por
     * @return SetorDetailsViewModelBuilder
     */
    public function setAlteradoPor($alterado_por)
    {
        $this->alterado_por = $alterado_por;
        return $this;
    }

    /**
     * @param mixed $desativado_por
     * @return SetorDetailsViewModelBuilder
     */
    public function setDesativadoPor($desativado_por)
    {
        $this->desativado_por = $desativado_por;
        return $this;
    }

    public function build() : SetorDetailsViewModel
    {
        $paciente_details_vm = new SetorDetailsViewModel();
        $paciente_details_vm->setId($this->id);
        $paciente_details_vm->setDescricao($this->descricao);
        $paciente_details_vm->setIdCentroCusto($this->id_centro_custo);
        $paciente_details_vm->setDescricaoCentroCusto($this->descricao_centro_custo);
        $paciente_details_vm->setCriadoEm($this->criado_em);
        $paciente_details_vm->setAtualizadoEm($this->atualizado_em);
        $paciente_details_vm->setCriadoPor($this->criado_por);
        $paciente_details_vm->setAlteradoPor($this->alterado_por);
        $paciente_details_vm->setDesativadoEm($this->desativado_em);
        $paciente_details_vm->setDesativadoPor($this->desativado_por);
        return $paciente_details_vm;
    }


}
